commit ecd031a9470257324484c66b51c6baff943e01ab
Author: Christophe Lyon <christophe.lyon@linaro.org>
Date:   Mon Dec 23 08:11:34 2024 +0000

    Revert "arm: [MVE intrinsics] Fix support for predicate constants [PR target/114801]"
    
    This reverts commit 0631c5770e8162dbe67c73dee0327313c19822c2.

diff --git a/gcc/config/arm/arm-mve-builtins.cc b/gcc/config/arm/arm-mve-builtins.cc
index ec856f7d616..e1826ae4052 100644
--- a/gcc/config/arm/arm-mve-builtins.cc
+++ b/gcc/config/arm/arm-mve-builtins.cc
@@ -2107,37 +2107,7 @@ function_expander::add_input_operand (insn_code icode, rtx x)
       mode = GET_MODE (x);
     }
   else if (VALID_MVE_PRED_MODE (mode))
-    {
-      if (CONST_INT_P (x))
-	{
-	  if (mode == V8BImode || mode == V4BImode)
-	    {
-	      /* In V8BI or V4BI each element has 2 or 4 bits, if those bits
-		 aren't all the same, gen_lowpart might ICE.  Canonicalize all
-		 the 2 or 4 bits to all ones if any of them is non-zero.  V8BI
-		 and V4BI multi-bit masks are interpreted byte-by-byte at
-		 instruction level, but such constants should describe lanes,
-		 rather than bytes.  See the section on MVE intrinsics in the
-		 Arm ACLE specification.  */
-	      unsigned HOST_WIDE_INT xi = UINTVAL (x);
-	      xi |= ((xi & 0x5555) << 1) | ((xi & 0xaaaa) >> 1);
-	      if (mode == V4BImode)
-		xi |= ((xi & 0x3333) << 2) | ((xi & 0xcccc) >> 2);
-	      if (xi != UINTVAL (x))
-		warning_at (location, 0, "constant predicate argument %d"
-			    " (%wx) does not map to %d lane numbers,"
-			    " converted to %wx",
-			    opno, UINTVAL (x) & 0xffff,
-			    mode == V8BImode ? 8 : 4,
-			    xi & 0xffff);
-
-	      x = gen_int_mode (xi, HImode);
-	    }
-	  x = gen_lowpart (mode, x);
-	}
-      else
-	x = force_lowpart_subreg (mode, x, GET_MODE (x));
-    }
+    x = gen_lowpart (mode, x);
 
   m_ops.safe_grow (m_ops.length () + 1, true);
   create_input_operand (&m_ops.last (), x, mode);
diff --git a/gcc/testsuite/gcc.target/arm/mve/pr108443-run.c b/gcc/testsuite/gcc.target/arm/mve/pr108443-run.c
index b894f019b8b..cb4b45bd305 100644
--- a/gcc/testsuite/gcc.target/arm/mve/pr108443-run.c
+++ b/gcc/testsuite/gcc.target/arm/mve/pr108443-run.c
@@ -16,7 +16,7 @@ __attribute__ ((noipa)) partial_write (uint32_t *a, uint32x4_t v, unsigned short
 
 int main (void)
 {
-  unsigned short p = 0x00FF;
+  unsigned short p = 0x00CC;
   uint32_t a[] = {0, 0, 0, 0};
   uint32_t b[] = {0, 0, 0, 0};
   uint32x4_t v = vdupq_n_u32 (0xFFFFFFFFU);
diff --git a/gcc/testsuite/gcc.target/arm/mve/pr108443.c b/gcc/testsuite/gcc.target/arm/mve/pr108443.c
index 0c0e2dd6eb8..c5fbfa4a1bb 100644
--- a/gcc/testsuite/gcc.target/arm/mve/pr108443.c
+++ b/gcc/testsuite/gcc.target/arm/mve/pr108443.c
@@ -7,8 +7,8 @@
 void
 __attribute__ ((noipa)) partial_write_cst (uint32_t *a, uint32x4_t v)
 {
-  vstrwq_p_u32 (a, v, 0x00FF);
+  vstrwq_p_u32 (a, v, 0x00CC);
 }
 
-/* { dg-final { scan-assembler {mov\tr[0-9]+, #255} } } */
+/* { dg-final { scan-assembler {mov\tr[0-9]+, #204} } } */
 
